// 214_1.cpp:   .

#include "stdafx.h"

#include <stdio.h> // printf()
#include <conio.h> // _getch() 
#include <vcclr.h> // PtrToStringChars()

using namespace System;
using namespace System::Runtime::InteropServices;

#pragma unmanaged
void NativeTakesAString(const wchar_t* p)
{
	printf("(native) recieved '%S'\n", p);
}
#pragma managed

void main()
{
	String^ s = gcnew String("test string"); 
	pin_ptr<const wchar_t> str = PtrToStringChars(s);

	//   s      
	// native-  _const_Char_ptr  
	//  .     
	// [cli::]pin_ptr<cv_qualifier type> var = ^initializer; 
	//    const wchar_t. 
	// :
	// cv_qualifier -  const   volatile. 
	//  volatile ,    
	//   ,   
	//  ,       
	//    .   pin_ptr  
	//    volatile,    
	//   const,       
	//  ,     .
	// initializer -    :  
	// managed-    ,  
	//   native-.
	//  PtrToStringChars()      :
	// native-   (managed) .
	// type -  initializer'.     wchar_t 
	// var -   pin_ptr .    
	// str. .. str -   native- String  
	//  .

	Console::WriteLine("(managed) passing string to native func...");
	//    managed-
	NativeTakesAString( str );
	//  native-,   native-
	_getch();
}
